%undefine __cmake_in_source_build

Summary: A PDF file viewer for the X Window System
Name: xpdf
Version: 4.04
Release: 2%{?dist}
License: (GPL-2.0-only OR GPL-3.0-only) AND BSD-3-Clause
Url: http://www.xpdfreader.com/

Source0: http://www.xpdfreader.com/dl/%{name}-%{version}.tar.gz
Source3: xpdf-chinese-simplified-2020-dec-22-NOCMAP.tar.gz
Source4: xpdf-chinese-traditional-2020-dec-22-NOCMAP.tar.gz
Source5: xpdf-japanese-2020-dec-22-NOCMAP.tar.gz
Source6: xpdf-korean-2020-dec-22-NOCMAP.tar.gz
Source7: ftp://ftp.foolabs.com/pub/xpdf/xpdf-cyrillic-2011-aug-15.tar.gz
Source8: ftp://ftp.foolabs.com/pub/xpdf/xpdf-thai-2011-aug-15.tar.gz
Source10: xpdf.desktop
Source11: xpdf.png
Source12: ftp://ftp.foolabs.com/pub/xpdf/xpdf-arabic-2011-aug-15.tar.gz
Source13: ftp://ftp.foolabs.com/pub/xpdf/xpdf-greek-2011-aug-15.tar.gz
Source14: ftp://ftp.foolabs.com/pub/xpdf/xpdf-hebrew-2011-aug-15.tar.gz
Source15: ftp://ftp.foolabs.com/pub/xpdf/xpdf-latin2-2011-aug-15.tar.gz
Source16: ftp://ftp.foolabs.com/pub/xpdf/xpdf-turkish-2011-aug-15.tar.gz

Patch3: xpdf-4.01-ext.patch
Patch9: xpdf-3.00-papersize.patch
Patch11: xpdf-4.01-crash.patch
Patch12: xpdf-4.01-64bit.patch
Patch15: xpdf-3.04-nocmap.patch
Patch25: xpdf-4.00-versionedlib.patch
Patch26: xpdf-4.02-urw-base35-fonts.patch
Patch28: xpdf-4.04-GlobalParams-null-fix.patch
Patch29: xpdf-4.04-shared-xpdf-lib.patch

Patch101: xpdf-4.02-CVE-2019-12360.patch

Patch200: xpdf-4.02-permissions.patch
Patch203: fix-444648.dpatch

Requires: urw-fonts
Requires: xdg-utils
Requires: poppler-utils
Requires: xorg-x11-fonts-ISO8859-1-75dpi
Requires: xorg-x11-fonts-ISO8859-1-100dpi
Requires: qt5-qtsvg

BuildRequires: qt5-qtbase-devel, cmake
BuildRequires: freetype-devel >= 2.1.7
BuildRequires: fontconfig-devel
BuildRequires: desktop-file-utils
BuildRequires: libpaper-devel
BuildRequires: libpng-devel
BuildRequires: libXpm-devel
BuildRequires: cups-devel

Provides:  %{name}-chinese-simplified = %{version}-%{release}
Provides:  %{name}-chinese-traditional = %{version}-%{release}
Provides:  %{name}-korean = %{version}-%{release}
Provides:  %{name}-japanese = %{version}-%{release}

Requires: %{name}-libs = %{version}-%{release}

%description
Xpdf is an X Window System based viewer for Portable Document Format
(PDF) files. Xpdf is a small and efficient program which uses
standard X fonts.

%package devel
Requires: %{name} = %{version}-%{release}
Requires: libpaper-devel
Requires: fontconfig-devel, freetype-devel
Requires: libpng-devel
Summary: Development files for xpdf libraries

%description devel
Development files for xpdf libraries.

%package libs
Summary: Libraries from xpdf

%description libs
Libraries from xpdf.

%prep
%setup -q -a 3 -a 4 -a 5 -a 6 -a 7 -a 8 -a 12 -a 13 -a 14 -a 15 -a 16
%patch -P3 -p1 -b .ext
%patch -P9 -p1 -b .papersize
%patch -P11 -p1 -b .crash
%patch -P12 -p1 -b .alloc
%patch -P25 -p1 -b .versionedlib
%patch -P26 -p1 -b .urw-font-fix
%patch -P28 -p1 -b .GlobalParams-null-fix
%patch -P29 -p1 -b .shared-xpdf-lib

%patch -P101 -p1 -b .CVE-2019-12360

%patch -P200 -p1 -b .permissions
%patch -P203 -p1 -b .64bit-stream

sed -i 's|urlCommand|#urlCommand|g' doc/sample-xpdfrc

%build
find -name "*orig" | xargs rm -f

for file in doc/*.1 doc/*.5 xpdf-*/README; do
  sed -i -e 's:/etc/xpdfrc:%{_sysconfdir}/xpdfrc:g' $file
done
for file in xpdf-*/README xpdf-*/add-to-xpdfrc; do
  sed -i -e 's:/usr/share/:%{_datadir}/:g' $file
  sed -i -e 's:/usr/local/share/:%{_datadir}/:g' $file
done

export CFLAGS="%{optflags} -fPIC"
export CXXFLAGS="%{optflags} -Wno-deprecated -fPIC"
%cmake -DMULTITHREADED=ON -DOPI_SUPPORT=ON -DXPDFWIDGET_PRINTING=1 -DSYSTEM_XPDFRC="%{_sysconfdir}/xpdfrc"

%cmake_build
%cmake_build --target xpdf

%install
mkdir -p %{buildroot}%{_datadir}/xpdf/arabic \
         %{buildroot}%{_datadir}/xpdf/chinese-simplified \
         %{buildroot}%{_datadir}/xpdf/chinese-traditional \
         %{buildroot}%{_datadir}/xpdf/cyrillic \
         %{buildroot}%{_datadir}/xpdf/greek \
         %{buildroot}%{_datadir}/xpdf/hebrew \
         %{buildroot}%{_datadir}/xpdf/japanese \
         %{buildroot}%{_datadir}/xpdf/korean \
         %{buildroot}%{_datadir}/xpdf/latin2 \
         %{buildroot}%{_datadir}/xpdf/thai \
         %{buildroot}%{_datadir}/xpdf/turkish \
         %{buildroot}%{_datadir}/icons/hicolor/48x48/apps

%cmake_install

mkdir -p %{buildroot}%{_libdir}
cp -a %{_vpath_builddir}/fofi/libfofi.so* %{buildroot}%{_libdir}
cp -a %{_vpath_builddir}/goo/libgoo.so* %{buildroot}%{_libdir}
cp -a %{_vpath_builddir}/splash/libsplash.so* %{buildroot}%{_libdir}
cp -a %{_vpath_builddir}/xpdf/libxpdfcore.so* %{buildroot}%{_libdir}

mkdir -p %{buildroot}%{_includedir}/xpdf/fofi
mkdir -p %{buildroot}%{_includedir}/xpdf/goo
mkdir -p %{buildroot}%{_includedir}/xpdf/splash
cp -a fofi/*.h %{buildroot}%{_includedir}/xpdf/fofi/
cp -a goo/*.h %{buildroot}%{_includedir}/xpdf/goo/
cp -a splash/*.h %{buildroot}%{_includedir}/xpdf/splash/
cp -a xpdf/*.h %{buildroot}%{_includedir}/xpdf/
cp -a %{__cmake_builddir}/aconf.h %{buildroot}%{_includedir}/xpdf/
cp -a aconf2.h %{buildroot}%{_includedir}/xpdf/

mkdir -p %{buildroot}%{_datadir}/applications/
desktop-file-install            \
        --dir %{buildroot}%{_datadir}/applications   \
        --add-category X-OpenCloudOS \
        %{SOURCE10}
install -m 0644 %{SOURCE11} %{buildroot}%{_datadir}/icons/hicolor/48x48/apps/xpdf.png

cp -pr xpdf-arabic/* %{buildroot}%{_datadir}/xpdf/arabic/
cp -pr xpdf-chinese-simplified/* %{buildroot}%{_datadir}/xpdf/chinese-simplified/
cp -pr xpdf-chinese-traditional/* %{buildroot}%{_datadir}/xpdf/chinese-traditional/
cp -pr xpdf-cyrillic/* %{buildroot}%{_datadir}/xpdf/cyrillic/
cp -pr xpdf-greek/* %{buildroot}%{_datadir}/xpdf/greek/
cp -pr xpdf-hebrew/* %{buildroot}%{_datadir}/xpdf/hebrew/
cp -pr xpdf-japanese/* %{buildroot}%{_datadir}/xpdf/japanese/
cp -pr xpdf-korean/* %{buildroot}%{_datadir}/xpdf/korean/
cp -pr xpdf-latin2/* %{buildroot}%{_datadir}/xpdf/latin2/
cp -pr xpdf-thai/* %{buildroot}%{_datadir}/xpdf/thai/
cp -pr xpdf-turkish/* %{buildroot}%{_datadir}/xpdf/turkish/

rm %{buildroot}%{_bindir}/pdfdetach
rm %{buildroot}%{_bindir}/pdffonts
rm %{buildroot}%{_bindir}/pdfimages
rm %{buildroot}%{_bindir}/pdfinfo
rm %{buildroot}%{_bindir}/pdftohtml
rm %{buildroot}%{_bindir}/pdftops
rm %{buildroot}%{_bindir}/pdftotext
rm %{buildroot}%{_bindir}/pdftoppm
rm %{buildroot}%{_mandir}/man1/pdftoppm.1*
rm %{buildroot}%{_mandir}/man1/pdfdetach.1*
rm %{buildroot}%{_mandir}/man1/pdffonts.1*
rm %{buildroot}%{_mandir}/man1/pdfimages.1*
rm %{buildroot}%{_mandir}/man1/pdfinfo.1*
rm %{buildroot}%{_mandir}/man1/pdftohtml.1*
rm %{buildroot}%{_mandir}/man1/pdftops.1*
rm %{buildroot}%{_mandir}/man1/pdftotext.1*

mkdir -p %{buildroot}%{_sysconfdir}/xpdf/
for i in arabic chinese-simplified chinese-traditional cyrillic greek hebrew japanese korean latin2 thai turkish; do
     mv %{buildroot}%{_datadir}/%{name}/$i/README README.$i
     mv %{buildroot}%{_datadir}/%{name}/$i/add-to-xpdfrc %{buildroot}%{_sysconfdir}/xpdf/add-to-xpdfrc.$i
done

mkdir -p %{buildroot}%{_sysconfdir}/
cp -a doc/sample-xpdfrc %{buildroot}%{_sysconfdir}/xpdfrc
sed -i -e 's:/usr/local/share/:%{_datadir}/:g' %{buildroot}%{_sysconfdir}/xpdfrc


%files
%license COPYING COPYING3
%doc CHANGES README README.*
%{_bindir}/xpdf
%{_bindir}/pdftopng
%{_libdir}/lib*.so.*
%{_mandir}/man?/pdftopng*
%{_mandir}/man?/xpdf*
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdfrc
%dir %{_sysconfdir}/xpdf
%lang(ar) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.arabic
%lang(zh_CN) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.chinese-simplified
%lang(zh_TW) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.chinese-traditional
%lang(el) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.greek
%lang(iw) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.hebrew
%lang(ja) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.japanese
%lang(ko) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.korean
%lang(th) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.thai
%lang(tr) %config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.turkish
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.cyrillic
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xpdf/add-to-xpdfrc.latin2
%{_datadir}/icons/hicolor/48x48/apps/xpdf.png
%dir %{_datadir}/xpdf
%{_datadir}/applications/*
%lang(ar) %{_datadir}/xpdf/arabic
%lang(zh_CN) %{_datadir}/xpdf/chinese-simplified
%lang(zh_TW) %{_datadir}/xpdf/chinese-traditional
%lang(el) %{_datadir}/xpdf/greek
%lang(iw) %{_datadir}/xpdf/hebrew
%lang(ja) %{_datadir}/xpdf/japanese
%lang(ko) %{_datadir}/xpdf/korean
%lang(th) %{_datadir}/xpdf/thai
%lang(tr) %{_datadir}/xpdf/turkish
%{_datadir}/xpdf/cyrillic
%{_datadir}/xpdf/latin2

%files devel
%{_includedir}/xpdf/
%{_libdir}/lib*.so

%files libs
%{_libdir}/lib*.so.*

%changelog
* Tue Apr 23 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.04-2
- rebase to add ocs and ts macros

* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.04-1
- initial build
